/* DeviceRow.c generated by valac 0.48.14, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#define BLUETOOTH_TYPE_DEVICE_ROW (bluetooth_device_row_get_type ())
#define BLUETOOTH_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow))
#define BLUETOOTH_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))
#define BLUETOOTH_IS_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_IS_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_DEVICE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))

typedef struct _BluetoothDeviceRow BluetoothDeviceRow;
typedef struct _BluetoothDeviceRowClass BluetoothDeviceRowClass;
typedef struct _BluetoothDeviceRowPrivate BluetoothDeviceRowPrivate;

#define BLUETOOTH_SERVICES_TYPE_DEVICE (bluetooth_services_device_get_type ())
#define BLUETOOTH_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice))
#define BLUETOOTH_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE))
#define BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDeviceIface))

typedef struct _BluetoothServicesDevice BluetoothServicesDevice;
typedef struct _BluetoothServicesDeviceIface BluetoothServicesDeviceIface;

#define BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY (bluetooth_services_device_proxy_get_type ())

#define BLUETOOTH_SERVICES_TYPE_ADAPTER (bluetooth_services_adapter_get_type ())
#define BLUETOOTH_SERVICES_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter))
#define BLUETOOTH_SERVICES_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER))
#define BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapterIface))

typedef struct _BluetoothServicesAdapter BluetoothServicesAdapter;
typedef struct _BluetoothServicesAdapterIface BluetoothServicesAdapterIface;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER_PROXY (bluetooth_services_adapter_proxy_get_type ())
enum  {
	BLUETOOTH_DEVICE_ROW_0_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY,
	BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY,
	BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES];
typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED,
	BLUETOOTH_DEVICE_ROW_STATUS_PAIRING,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED
} BluetoothDeviceRowStatus;

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothDeviceRowButtonClickedData BluetoothDeviceRowButtonClickedData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL,
	BLUETOOTH_DEVICE_ROW_NUM_SIGNALS
};
static guint bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _BluetoothDeviceRow {
	GtkListBoxRow parent_instance;
	BluetoothDeviceRowPrivate * priv;
};

struct _BluetoothDeviceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _BluetoothServicesDeviceIface {
	GTypeInterface parent_iface;
	void (*cancel_pairing) (BluetoothServicesDevice* self, GError** error);
	void (*connect) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*connect_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	void (*connect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*disconnect) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*disconnect_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	void (*disconnect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*pair) (BluetoothServicesDevice* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*pair_finish) (BluetoothServicesDevice* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesDevice* self, gint* result_length1);
	gboolean (*get_blocked) (BluetoothServicesDevice* self);
	void (*set_blocked) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_connected) (BluetoothServicesDevice* self);
	gboolean (*get_legacy_pairing) (BluetoothServicesDevice* self);
	gboolean (*get_paired) (BluetoothServicesDevice* self);
	gboolean (*get_trusted) (BluetoothServicesDevice* self);
	void (*set_trusted) (BluetoothServicesDevice* self, gboolean value);
	gint16 (*get_RSSI) (BluetoothServicesDevice* self);
	char* (*get_adapter) (BluetoothServicesDevice* self);
	gchar* (*get_address) (BluetoothServicesDevice* self);
	gchar* (*get_alias) (BluetoothServicesDevice* self);
	void (*set_alias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_icon) (BluetoothServicesDevice* self);
	gchar* (*get_modalias) (BluetoothServicesDevice* self);
	gchar* (*get_name) (BluetoothServicesDevice* self);
	guint16 (*get_appearance) (BluetoothServicesDevice* self);
	guint32 (*get_class) (BluetoothServicesDevice* self);
};

struct _BluetoothServicesAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothServicesAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothServicesAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*start_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	void (*stop_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*stop_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesAdapter* self, gint* result_length1);
	gboolean (*get_discoverable) (BluetoothServicesAdapter* self);
	void (*set_discoverable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothServicesAdapter* self);
	gboolean (*get_pairable) (BluetoothServicesAdapter* self);
	void (*set_pairable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothServicesAdapter* self);
	void (*set_powered) (BluetoothServicesAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothServicesAdapter* self);
	gchar* (*get_alias) (BluetoothServicesAdapter* self);
	void (*set_alias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesAdapter* self);
	gchar* (*get_name) (BluetoothServicesAdapter* self);
	guint (*get_class) (BluetoothServicesAdapter* self);
	guint (*get_discoverable_timeout) (BluetoothServicesAdapter* self);
	guint (*get_pairable_timeout) (BluetoothServicesAdapter* self);
};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	GtkButton* connect_button;
	GtkButton* forget_button;
	GtkImage* state;
	GtkLabel* state_label;
	GtkLinkButton* settings_button;
};

struct _BluetoothDeviceRowButtonClickedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothDeviceRow* self;
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	BluetoothServicesDevice* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	BluetoothServicesDevice* _tmp9_;
	GError* _vala1_e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	BluetoothServicesDevice* _tmp12_;
	GError* _vala2_e;
	GtkImage* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};

static gint BluetoothDeviceRow_private_offset;
static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

GType bluetooth_device_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BluetoothDeviceRow, g_object_unref)
GType bluetooth_services_device_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_device_register_object (void* object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error);
GType bluetooth_services_device_get_type (void) G_GNUC_CONST;
GType bluetooth_services_adapter_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_adapter_register_object (void* object,
                                                  GDBusConnection* connection,
                                                  const gchar* path,
                                                  GError** error);
GType bluetooth_services_adapter_get_type (void) G_GNUC_CONST;
static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
BluetoothDeviceRow* bluetooth_device_row_new (BluetoothServicesDevice* device,
                                              BluetoothServicesAdapter* adapter);
BluetoothDeviceRow* bluetooth_device_row_construct (GType object_type,
                                                    BluetoothServicesDevice* device,
                                                    BluetoothServicesAdapter* adapter);
static void bluetooth_device_row_button_clicked_data_free (gpointer _data);
static void bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                                 GAsyncResult* _res_);
static gboolean bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_);
BluetoothServicesDevice* bluetooth_device_row_get_device (BluetoothDeviceRow* self);
gboolean bluetooth_services_device_get_paired (BluetoothServicesDevice* self);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                      BluetoothDeviceRowStatus status);
void bluetooth_services_device_pair (BluetoothServicesDevice* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void bluetooth_services_device_pair_finish (BluetoothServicesDevice* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static void bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
gboolean bluetooth_services_device_get_connected (BluetoothServicesDevice* self);
void bluetooth_services_device_connect (BluetoothServicesDevice* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void bluetooth_services_device_connect_finish (BluetoothServicesDevice* self,
                                               GAsyncResult* _res_,
                                               GError** error);
void bluetooth_services_device_disconnect (BluetoothServicesDevice* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void bluetooth_services_device_disconnect_finish (BluetoothServicesDevice* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void bluetooth_device_row_compute_status (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                      BluetoothServicesDevice* value);
BluetoothServicesAdapter* bluetooth_device_row_get_adapter (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                       BluetoothServicesAdapter* value);
static GObject * bluetooth_device_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
gchar* bluetooth_services_device_get_icon (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_address (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_name (BluetoothServicesDevice* self);
gboolean bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
static void _bluetooth_device_row___lambda23_ (BluetoothDeviceRow* self,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda24_ (Block1Data* _data1_,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda25_ (BluetoothDeviceRow* self);
void bluetooth_services_device_set_trusted (BluetoothServicesDevice* self,
                                            gboolean value);
static void __bluetooth_device_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static gboolean _bluetooth_device_row___lambda26_ (BluetoothDeviceRow* self);
void bluetooth_services_adapter_remove_device (BluetoothServicesAdapter* self,
                                               const char* device,
                                               GError** error);
static gboolean __bluetooth_device_row___lambda26__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self);
static void bluetooth_device_row_finalize (GObject * obj);
static GType bluetooth_device_row_get_type_once (void);
static void _vala_bluetooth_device_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
bluetooth_device_row_get_instance_private (BluetoothDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothDeviceRow_private_offset);
}

static gchar*
bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self)
{
	gchar* result = NULL;
	switch (self) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Available"));
			result = _tmp0_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Pairing…"));
			result = _tmp1_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Connected"));
			result = _tmp2_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Connecting…"));
			result = _tmp3_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Disconnecting…"));
			result = _tmp4_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Unable to Connect"));
			result = _tmp5_;
			return result;
		}
		default:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Not Connected"));
			result = _tmp6_;
			return result;
		}
	}
}

static GType
bluetooth_device_row_status_get_type_once (void)
{
	static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED", "unpaired"}, {BLUETOOTH_DEVICE_ROW_STATUS_PAIRING, "BLUETOOTH_DEVICE_ROW_STATUS_PAIRING", "pairing"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED", "unable-to-connect-paired"}, {0, NULL, NULL}};
	GType bluetooth_device_row_status_type_id;
	bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
	return bluetooth_device_row_status_type_id;
}

static GType
bluetooth_device_row_status_get_type (void)
{
	static volatile gsize bluetooth_device_row_status_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__volatile)) {
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = bluetooth_device_row_status_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_status_type_id__volatile, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__volatile;
}

BluetoothDeviceRow*
bluetooth_device_row_construct (GType object_type,
                                BluetoothServicesDevice* device,
                                BluetoothServicesAdapter* adapter)
{
	BluetoothDeviceRow * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (adapter != NULL, NULL);
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
	return self;
}

BluetoothDeviceRow*
bluetooth_device_row_new (BluetoothServicesDevice* device,
                          BluetoothServicesAdapter* adapter)
{
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
}

static void
bluetooth_device_row_button_clicked_data_free (gpointer _data)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (BluetoothDeviceRowButtonClickedData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	BluetoothDeviceRow* _tmp0_;
	_data_ = g_slice_new0 (BluetoothDeviceRowButtonClickedData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_device_row_button_clicked_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static void
bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                            GAsyncResult* _res_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static gboolean
bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_device;
	_data_->_tmp1_ = bluetooth_services_device_get_paired (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	if (!_data_->_tmp2_) {
		bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_PAIRING);
		{
			_data_->_tmp3_ = _data_->self->priv->_device;
			_data_->_state_ = 1;
			bluetooth_services_device_pair (_data_->_tmp3_, bluetooth_device_row_button_clicked_ready, _data_);
			return FALSE;
			_state_1:
			bluetooth_services_device_pair_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
			_data_->_tmp4_ = _data_->e;
			_data_->_tmp5_ = _data_->_tmp4_->message;
			g_critical ("DeviceRow.vala:246: %s", _data_->_tmp5_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->_tmp6_ = _data_->self->priv->_device;
		_data_->_tmp7_ = bluetooth_services_device_get_connected (_data_->_tmp6_);
		_data_->_tmp8_ = _data_->_tmp7_;
		if (!_data_->_tmp8_) {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
			{
				_data_->_tmp9_ = _data_->self->priv->_device;
				_data_->_state_ = 2;
				bluetooth_services_device_connect (_data_->_tmp9_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_2:
				bluetooth_services_device_connect_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				_data_->_vala1_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED);
				_data_->_tmp10_ = _data_->_vala1_e;
				_data_->_tmp11_ = _data_->_tmp10_->message;
				g_critical ("DeviceRow.vala:254: %s", _data_->_tmp11_);
				_g_error_free0 (_data_->_vala1_e);
			}
			__finally1:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		} else {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
			{
				_data_->_tmp12_ = _data_->self->priv->_device;
				_data_->_state_ = 3;
				bluetooth_services_device_disconnect (_data_->_tmp12_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_3:
				bluetooth_services_device_disconnect_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				_data_->_vala2_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				_data_->_tmp13_ = _data_->self->priv->state;
				g_object_set (_data_->_tmp13_, "icon-name", "user-busy", NULL);
				_data_->_tmp14_ = _data_->_vala2_e;
				_data_->_tmp15_ = _data_->_tmp14_->message;
				g_critical ("DeviceRow.vala:262: %s", _data_->_tmp15_);
				_g_error_free0 (_data_->_vala2_e);
			}
			__finally2:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
bluetooth_device_row_compute_status (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = bluetooth_services_device_get_paired (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED);
	} else {
		BluetoothServicesDevice* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->_device;
		_tmp4_ = bluetooth_services_device_get_connected (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
		} else {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
		}
	}
}

static void
bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                 BluetoothDeviceRowStatus status)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state_label;
	_tmp1_ = bluetooth_device_row_status_to_string (status);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp2_);
	_tmp4_ = _tmp3_;
	gtk_label_set_label (_tmp0_, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp5_ = self->priv->state;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
	_tmp6_ = self->priv->state;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	switch (status) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			GtkButton* _tmp7_;
			GtkButton* _tmp8_;
			GtkLinkButton* _tmp9_;
			GtkImage* _tmp10_;
			GtkImage* _tmp11_;
			GtkButton* _tmp12_;
			_tmp7_ = self->priv->connect_button;
			gtk_button_set_label (_tmp7_, _ ("Pair"));
			_tmp8_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
			_tmp9_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
			_tmp10_ = self->priv->state;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
			_tmp11_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
			_tmp12_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			GtkButton* _tmp13_;
			GtkImage* _tmp14_;
			GtkLinkButton* _tmp15_;
			GtkButton* _tmp16_;
			_tmp13_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
			_tmp14_ = self->priv->state;
			g_object_set (_tmp14_, "icon-name", "user-away", NULL);
			_tmp15_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
			_tmp16_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp16_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			GtkButton* _tmp17_;
			GtkButton* _tmp18_;
			GtkImage* _tmp19_;
			GtkLinkButton* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			GtkButton* _tmp24_;
			GtkButton* _tmp25_;
			_tmp17_ = self->priv->connect_button;
			gtk_button_set_label (_tmp17_, _ ("Disconnect"));
			_tmp18_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, TRUE);
			_tmp19_ = self->priv->state;
			g_object_set (_tmp19_, "icon-name", "user-available", NULL);
			_tmp20_ = self->priv->settings_button;
			_tmp21_ = gtk_link_button_get_uri (_tmp20_);
			_tmp22_ = _tmp21_;
			if (g_strcmp0 (_tmp22_, "") != 0) {
				GtkLinkButton* _tmp23_;
				_tmp23_ = self->priv->settings_button;
				gtk_widget_set_visible ((GtkWidget*) _tmp23_, TRUE);
			}
			_tmp24_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, TRUE);
			_tmp25_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp25_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			GtkButton* _tmp26_;
			GtkImage* _tmp27_;
			GtkLinkButton* _tmp28_;
			GtkButton* _tmp29_;
			GtkButton* _tmp30_;
			_tmp26_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, FALSE);
			_tmp27_ = self->priv->state;
			g_object_set (_tmp27_, "icon-name", "user-away", NULL);
			_tmp28_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
			_tmp29_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, FALSE);
			_tmp30_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp30_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			GtkButton* _tmp31_;
			GtkImage* _tmp32_;
			GtkLinkButton* _tmp33_;
			GtkButton* _tmp34_;
			GtkButton* _tmp35_;
			_tmp31_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp31_, FALSE);
			_tmp32_ = self->priv->state;
			g_object_set (_tmp32_, "icon-name", "user-away", NULL);
			_tmp33_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
			_tmp34_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp34_, FALSE);
			_tmp35_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp35_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
		{
			GtkButton* _tmp36_;
			GtkButton* _tmp37_;
			GtkImage* _tmp38_;
			GtkLinkButton* _tmp39_;
			GtkButton* _tmp40_;
			GtkButton* _tmp41_;
			_tmp36_ = self->priv->connect_button;
			gtk_button_set_label (_tmp36_, _ ("Connect"));
			_tmp37_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp37_, TRUE);
			_tmp38_ = self->priv->state;
			g_object_set (_tmp38_, "icon-name", "user-offline", NULL);
			_tmp39_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
			_tmp40_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, TRUE);
			_tmp41_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp41_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		{
			GtkButton* _tmp42_;
			GtkImage* _tmp43_;
			GtkLinkButton* _tmp44_;
			GtkButton* _tmp45_;
			_tmp42_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp42_, TRUE);
			_tmp43_ = self->priv->state;
			g_object_set (_tmp43_, "icon-name", "user-busy", NULL);
			_tmp44_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp44_, FALSE);
			_tmp45_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp45_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
		{
			GtkButton* _tmp46_;
			GtkImage* _tmp47_;
			GtkLinkButton* _tmp48_;
			GtkButton* _tmp49_;
			GtkButton* _tmp50_;
			_tmp46_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp46_, TRUE);
			_tmp47_ = self->priv->state;
			g_object_set (_tmp47_, "icon-name", "user-offline", NULL);
			_tmp48_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp48_, FALSE);
			_tmp49_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp49_, TRUE);
			_tmp50_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp50_, TRUE);
			break;
		}
		default:
		break;
	}
	g_signal_emit (self, bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL], 0);
}

BluetoothServicesDevice*
bluetooth_device_row_get_device (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                 BluetoothServicesDevice* value)
{
	BluetoothServicesDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_device_row_get_device (self);
	if (old_value != value) {
		BluetoothServicesDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY]);
	}
}

BluetoothServicesAdapter*
bluetooth_device_row_get_adapter (BluetoothDeviceRow* self)
{
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_adapter;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                  BluetoothServicesAdapter* value)
{
	BluetoothServicesAdapter* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_device_row_get_adapter (self);
	if (old_value != value) {
		self->priv->_adapter = value;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY]);
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		BluetoothDeviceRow* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->label);
		_g_object_unref0 (_data1_->image);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
_bluetooth_device_row___lambda23_ (BluetoothDeviceRow* self,
                                   GVariant* changed,
                                   gchar** invalid)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	powered = _tmp3_;
	_tmp4_ = powered;
	if (_tmp4_ != NULL) {
		BluetoothServicesAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->_adapter;
		_tmp6_ = bluetooth_services_adapter_get_powered (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_g_variant_unref0 (powered);
}

static void
__bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda23_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties);
}

static void
_bluetooth_device_row___lambda24_ (Block1Data* _data1_,
                                   GVariant* changed,
                                   gchar** invalid)
{
	BluetoothDeviceRow* self;
	GVariant* paired = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* connected = NULL;
	GVariantType* _tmp6_;
	GVariantType* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* name = NULL;
	GVariantType* _tmp11_;
	GVariantType* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GVariant* icon = NULL;
	GVariantType* _tmp21_;
	GVariantType* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	self = _data1_->self;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Paired", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	paired = _tmp3_;
	_tmp4_ = paired;
	if (_tmp4_ != NULL) {
		BluetoothServicesDevice* _tmp5_;
		bluetooth_device_row_compute_status (self);
		_tmp5_ = self->priv->_device;
		bluetooth_services_device_connect (_tmp5_, NULL, NULL);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp6_ = g_variant_type_new ("b");
	_tmp7_ = _tmp6_;
	_tmp8_ = g_variant_lookup_value (changed, "Connected", _tmp7_);
	_tmp9_ = _tmp8_;
	_g_variant_type_free0 (_tmp7_);
	connected = _tmp9_;
	_tmp10_ = connected;
	if (_tmp10_ != NULL) {
		bluetooth_device_row_compute_status (self);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp11_ = g_variant_type_new ("s");
	_tmp12_ = _tmp11_;
	_tmp13_ = g_variant_lookup_value (changed, "Name", _tmp12_);
	_tmp14_ = _tmp13_;
	_g_variant_type_free0 (_tmp12_);
	name = _tmp14_;
	_tmp15_ = name;
	if (_tmp15_ != NULL) {
		GtkLabel* _tmp16_;
		BluetoothServicesDevice* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp16_ = _data1_->label;
		_tmp17_ = self->priv->_device;
		_tmp18_ = bluetooth_services_device_get_name (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = _tmp19_;
		gtk_label_set_label (_tmp16_, _tmp20_);
		_g_free0 (_tmp20_);
	}
	_tmp21_ = g_variant_type_new ("s");
	_tmp22_ = _tmp21_;
	_tmp23_ = g_variant_lookup_value (changed, "Icon", _tmp22_);
	_tmp24_ = _tmp23_;
	_g_variant_type_free0 (_tmp22_);
	icon = _tmp24_;
	_tmp25_ = icon;
	if (_tmp25_ != NULL) {
		gchar* _tmp26_ = NULL;
		BluetoothServicesDevice* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GtkImage* _tmp31_;
		_tmp27_ = self->priv->_device;
		_tmp28_ = bluetooth_services_device_get_icon (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp26_ = _tmp29_;
		if (_tmp26_ == NULL) {
			gchar* _tmp30_;
			_tmp30_ = g_strdup ("bluetooth");
			_g_free0 (_tmp26_);
			_tmp26_ = _tmp30_;
		}
		_tmp31_ = _data1_->image;
		g_object_set (_tmp31_, "icon-name", _tmp26_, NULL);
		_g_free0 (_tmp26_);
	}
	_g_variant_unref0 (icon);
	_g_variant_unref0 (name);
	_g_variant_unref0 (connected);
	_g_variant_unref0 (paired);
}

static void
__bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda24_ (self, changed_properties, invalidated_properties);
}

static void
_bluetooth_device_row___lambda25_ (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	bluetooth_device_row_button_clicked (self, NULL, NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_paired (_tmp1_);
	_tmp3_ = _tmp2_;
	bluetooth_services_device_set_trusted (_tmp0_, _tmp3_);
}

static void
__bluetooth_device_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_bluetooth_device_row___lambda25_ ((BluetoothDeviceRow*) self);
}

static gboolean
_bluetooth_device_row___lambda26_ (BluetoothDeviceRow* self)
{
	GError* _inner_error0_ = NULL;
	{
		BluetoothServicesAdapter* _tmp0_;
		BluetoothServicesDevice* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		char* _tmp5_;
		char* _tmp6_;
		_tmp0_ = self->priv->_adapter;
		_tmp1_ = self->priv->_device;
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_dbus_proxy_get_type (), GDBusProxy), "g-object-path", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = _tmp5_;
		bluetooth_services_adapter_remove_device (_tmp0_, _tmp6_, &_inner_error0_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_debug ("DeviceRow.vala:233: Forget bluetooth device failed: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp9_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp9_;
	}
}

static gboolean
__bluetooth_device_row___lambda26__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                    GdkEventButton* event,
                                                                    gpointer self)
{
	gboolean result;
	result = _bluetooth_device_row___lambda26_ ((BluetoothDeviceRow*) self);
	return result;
}

static GObject *
bluetooth_device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block1Data* _data1_;
	gchar* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp12_;
	GtkOverlay* _tmp13_;
	BluetoothServicesDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	gchar* device_name = NULL;
	BluetoothServicesDevice* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLinkButton* _tmp55_;
	GtkLinkButton* _tmp56_;
	GtkLinkButton* _tmp57_;
	GtkImage* _tmp58_;
	GtkImage* _tmp59_;
	GtkLinkButton* _tmp60_;
	GtkLinkButton* _tmp61_;
	GtkLinkButton* _tmp62_;
	GtkLinkButton* _tmp63_;
	GtkLinkButton* _tmp64_;
	gchar* _tmp65_;
	GtkButton* _tmp66_ = NULL;
	GtkButton* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkSizeGroup* _tmp71_;
	GtkButton* _tmp72_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp73_;
	GtkGrid* _tmp74_;
	GtkGrid* _tmp75_;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkOverlay* _tmp78_;
	GtkGrid* _tmp79_;
	GtkLabel* _tmp80_;
	GtkGrid* _tmp81_;
	GtkLabel* _tmp82_;
	GtkGrid* _tmp83_;
	GtkLinkButton* _tmp84_;
	GtkGrid* _tmp85_;
	GtkButton* _tmp86_;
	GtkGrid* _tmp87_;
	GtkButton* _tmp88_;
	GtkGrid* _tmp89_;
	BluetoothServicesDevice* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	GQuark _tmp95_ = 0U;
	static GQuark _tmp94_label0 = 0;
	static GQuark _tmp94_label1 = 0;
	static GQuark _tmp94_label2 = 0;
	static GQuark _tmp94_label3 = 0;
	static GQuark _tmp94_label4 = 0;
	BluetoothServicesAdapter* _tmp106_;
	gboolean _tmp107_;
	gboolean _tmp108_;
	BluetoothServicesAdapter* _tmp109_;
	BluetoothServicesDevice* _tmp110_;
	GtkButton* _tmp111_;
	GtkButton* _tmp112_;
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_icon (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("bluetooth");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp5_);
	_data1_->image = _tmp5_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->state);
	self->priv->state = _tmp6_;
	_tmp7_ = self->priv->state;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
	_tmp8_ = self->priv->state;
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->state_label);
	self->priv->state_label = _tmp9_;
	_tmp10_ = self->priv->state_label;
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
	_tmp11_ = self->priv->state_label;
	gtk_label_set_use_markup (_tmp11_, TRUE);
	_tmp12_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp12_);
	overlay = _tmp12_;
	_tmp13_ = overlay;
	_tmp14_ = self->priv->_device;
	_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = _tmp16_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp17_);
	_g_free0 (_tmp17_);
	_tmp18_ = overlay;
	_tmp19_ = _data1_->image;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = overlay;
	_tmp21_ = self->priv->state;
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = self->priv->_device;
	_tmp23_ = bluetooth_services_device_get_name (_tmp22_);
	_tmp24_ = _tmp23_;
	device_name = _tmp24_;
	_tmp25_ = device_name;
	if (_tmp25_ == NULL) {
		BluetoothServicesDevice* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gboolean _tmp30_;
		_tmp26_ = self->priv->_device;
		_tmp27_ = bluetooth_services_device_get_icon (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = _tmp28_;
		_tmp30_ = _tmp29_ != NULL;
		_g_free0 (_tmp29_);
		if (_tmp30_) {
			BluetoothServicesDevice* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			GQuark _tmp36_ = 0U;
			static GQuark _tmp35_label0 = 0;
			static GQuark _tmp35_label1 = 0;
			static GQuark _tmp35_label2 = 0;
			static GQuark _tmp35_label3 = 0;
			static GQuark _tmp35_label4 = 0;
			static GQuark _tmp35_label5 = 0;
			static GQuark _tmp35_label6 = 0;
			_tmp31_ = self->priv->_device;
			_tmp32_ = bluetooth_services_device_get_icon (_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp34_ = _tmp33_;
			_tmp36_ = (NULL == _tmp34_) ? 0 : g_quark_from_string (_tmp34_);
			g_free (_tmp34_);
			if (_tmp36_ == ((0 != _tmp35_label0) ? _tmp35_label0 : (_tmp35_label0 = g_quark_from_static_string ("audio-card")))) {
				switch (0) {
					default:
					{
						gchar* _tmp37_;
						_tmp37_ = g_strdup (_ ("Speaker"));
						_g_free0 (device_name);
						device_name = _tmp37_;
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label1) ? _tmp35_label1 : (_tmp35_label1 = g_quark_from_static_string ("input-gaming")))) {
				switch (0) {
					default:
					{
						gchar* _tmp38_;
						_tmp38_ = g_strdup (_ ("Controller"));
						_g_free0 (device_name);
						device_name = _tmp38_;
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label2) ? _tmp35_label2 : (_tmp35_label2 = g_quark_from_static_string ("input-keyboard")))) {
				switch (0) {
					default:
					{
						gchar* _tmp39_;
						_tmp39_ = g_strdup (_ ("Keyboard"));
						_g_free0 (device_name);
						device_name = _tmp39_;
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label3) ? _tmp35_label3 : (_tmp35_label3 = g_quark_from_static_string ("input-mouse")))) {
				switch (0) {
					default:
					{
						gchar* _tmp40_;
						_tmp40_ = g_strdup (_ ("Mouse"));
						_g_free0 (device_name);
						device_name = _tmp40_;
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label4) ? _tmp35_label4 : (_tmp35_label4 = g_quark_from_static_string ("input-tablet")))) {
				switch (0) {
					default:
					{
						gchar* _tmp41_;
						_tmp41_ = g_strdup (_ ("Tablet"));
						_g_free0 (device_name);
						device_name = _tmp41_;
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label5) ? _tmp35_label5 : (_tmp35_label5 = g_quark_from_static_string ("input-touchpad")))) {
				switch (0) {
					default:
					{
						gchar* _tmp42_;
						_tmp42_ = g_strdup (_ ("Touchpad"));
						_g_free0 (device_name);
						device_name = _tmp42_;
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label6) ? _tmp35_label6 : (_tmp35_label6 = g_quark_from_static_string ("phone")))) {
				switch (0) {
					default:
					{
						gchar* _tmp43_;
						_tmp43_ = g_strdup (_ ("Phone"));
						_g_free0 (device_name);
						device_name = _tmp43_;
						break;
					}
				}
			} else {
				switch (0) {
					default:
					{
						BluetoothServicesDevice* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						_tmp44_ = self->priv->_device;
						_tmp45_ = bluetooth_services_device_get_address (_tmp44_);
						_tmp46_ = _tmp45_;
						_g_free0 (device_name);
						device_name = _tmp46_;
					}
				}
			}
		} else {
			BluetoothServicesDevice* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			_tmp47_ = self->priv->_device;
			_tmp48_ = bluetooth_services_device_get_address (_tmp47_);
			_tmp49_ = _tmp48_;
			_g_free0 (device_name);
			device_name = _tmp49_;
		}
	}
	_tmp50_ = device_name;
	_tmp51_ = (GtkLabel*) gtk_label_new (_tmp50_);
	g_object_ref_sink (_tmp51_);
	_data1_->label = _tmp51_;
	_tmp52_ = _data1_->label;
	gtk_label_set_ellipsize (_tmp52_, PANGO_ELLIPSIZE_END);
	_tmp53_ = _data1_->label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp53_, TRUE);
	_tmp54_ = _data1_->label;
	gtk_label_set_xalign (_tmp54_, (gfloat) 0);
	_tmp55_ = (GtkLinkButton*) gtk_link_button_new ("");
	g_object_ref_sink (_tmp55_);
	_g_object_unref0 (self->priv->settings_button);
	self->priv->settings_button = _tmp55_;
	_tmp56_ = self->priv->settings_button;
	gtk_button_set_always_show_image ((GtkButton*) _tmp56_, TRUE);
	_tmp57_ = self->priv->settings_button;
	_tmp58_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp58_);
	_tmp59_ = _tmp58_;
	gtk_button_set_image ((GtkButton*) _tmp57_, (GtkWidget*) _tmp59_);
	_g_object_unref0 (_tmp59_);
	_tmp60_ = self->priv->settings_button;
	gtk_button_set_label ((GtkButton*) _tmp60_, NULL);
	_tmp61_ = self->priv->settings_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp61_, 3);
	_tmp62_ = self->priv->settings_button;
	gtk_widget_show_all ((GtkWidget*) _tmp62_);
	_tmp63_ = self->priv->settings_button;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp63_, TRUE);
	_tmp64_ = self->priv->settings_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp64_, FALSE);
	_tmp65_ = g_strdup (_ ("Forget this device"));
	_tmp66_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp66_, 3);
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp66_, TRUE);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp66_, _tmp65_);
	_g_free0 (_tmp65_);
	gtk_widget_set_visible ((GtkWidget*) _tmp66_, FALSE);
	g_object_ref_sink (_tmp66_);
	_g_object_unref0 (self->priv->forget_button);
	self->priv->forget_button = _tmp66_;
	_tmp67_ = self->priv->forget_button;
	_tmp68_ = gtk_widget_get_style_context ((GtkWidget*) _tmp67_);
	gtk_style_context_add_class (_tmp68_, GTK_STYLE_CLASS_FLAT);
	_tmp69_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp69_);
	_g_object_unref0 (self->priv->connect_button);
	self->priv->connect_button = _tmp69_;
	_tmp70_ = self->priv->connect_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp70_, GTK_ALIGN_CENTER);
	_tmp71_ = bluetooth_device_row_size_group;
	_tmp72_ = self->priv->connect_button;
	gtk_size_group_add_widget (_tmp71_, (GtkWidget*) _tmp72_);
	_tmp73_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp73_);
	grid = _tmp73_;
	_tmp74_ = grid;
	g_object_set ((GtkWidget*) _tmp74_, "margin", 6, NULL);
	_tmp75_ = grid;
	gtk_grid_set_column_spacing (_tmp75_, 6);
	_tmp76_ = grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp76_, GTK_ORIENTATION_HORIZONTAL);
	_tmp77_ = grid;
	_tmp78_ = overlay;
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 0, 1, 2);
	_tmp79_ = grid;
	_tmp80_ = _data1_->label;
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 0, 1, 1);
	_tmp81_ = grid;
	_tmp82_ = self->priv->state_label;
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, 1, 1, 1, 1);
	_tmp83_ = grid;
	_tmp84_ = self->priv->settings_button;
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, 2, 0, 1, 2);
	_tmp85_ = grid;
	_tmp86_ = self->priv->forget_button;
	gtk_grid_attach (_tmp85_, (GtkWidget*) _tmp86_, 3, 0, 1, 2);
	_tmp87_ = grid;
	_tmp88_ = self->priv->connect_button;
	gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, 4, 0, 1, 2);
	_tmp89_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp89_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp90_ = self->priv->_device;
	_tmp91_ = bluetooth_services_device_get_icon (_tmp90_);
	_tmp92_ = _tmp91_;
	_tmp93_ = _tmp92_;
	_tmp95_ = (NULL == _tmp93_) ? 0 : g_quark_from_string (_tmp93_);
	g_free (_tmp93_);
	if (_tmp95_ == ((0 != _tmp94_label0) ? _tmp94_label0 : (_tmp94_label0 = g_quark_from_static_string ("audio-card")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp96_;
				GtkLinkButton* _tmp97_;
				_tmp96_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp96_, "settings://sound");
				_tmp97_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp97_, _ ("Sound Settings"));
				break;
			}
		}
	} else if ((_tmp95_ == ((0 != _tmp94_label1) ? _tmp94_label1 : (_tmp94_label1 = g_quark_from_static_string ("input-gaming")))) || (_tmp95_ == ((0 != _tmp94_label2) ? _tmp94_label2 : (_tmp94_label2 = g_quark_from_static_string ("input-keyboard"))))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp98_;
				GtkLinkButton* _tmp99_;
				_tmp98_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp98_, "settings://input/keyboard");
				_tmp99_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp99_, _ ("Keyboard Settings"));
				break;
			}
		}
	} else if (_tmp95_ == ((0 != _tmp94_label3) ? _tmp94_label3 : (_tmp94_label3 = g_quark_from_static_string ("input-mouse")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp100_;
				GtkLinkButton* _tmp101_;
				_tmp100_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp100_, "settings://input/mouse");
				_tmp101_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp101_, _ ("Mouse & Touchpad Settings"));
				break;
			}
		}
	} else if (_tmp95_ == ((0 != _tmp94_label4) ? _tmp94_label4 : (_tmp94_label4 = g_quark_from_static_string ("printer")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp102_;
				GtkLinkButton* _tmp103_;
				_tmp102_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp102_, "settings://printer");
				_tmp103_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp103_, _ ("Printer Settings"));
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp104_;
				GtkLinkButton* _tmp105_;
				_tmp104_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp104_, NULL);
				_tmp105_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp105_, NULL);
				break;
			}
		}
	}
	bluetooth_device_row_compute_status (self);
	_tmp106_ = self->priv->_adapter;
	_tmp107_ = bluetooth_services_adapter_get_powered (_tmp106_);
	_tmp108_ = _tmp107_;
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp108_);
	_tmp109_ = self->priv->_adapter;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp109_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed, self, 0);
	_tmp110_ = self->priv->_device;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp111_ = self->priv->connect_button;
	g_signal_connect_object (_tmp111_, "clicked", (GCallback) __bluetooth_device_row___lambda25__gtk_button_clicked, self, 0);
	_tmp112_ = self->priv->forget_button;
	g_signal_connect_object ((GtkWidget*) _tmp112_, "button-release-event", (GCallback) __bluetooth_device_row___lambda26__gtk_widget_button_release_event, self, 0);
	_g_object_unref0 (grid);
	_g_free0 (device_name);
	_g_object_unref0 (overlay);
	_g_free0 (_tmp0_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return obj;
}

static void
bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass,
                                 gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothDeviceRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL] = g_signal_new ("status-changed", BLUETOOTH_TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	_g_object_unref0 (bluetooth_device_row_size_group);
	bluetooth_device_row_size_group = _tmp0_;
}

static void
bluetooth_device_row_instance_init (BluetoothDeviceRow * self,
                                    gpointer klass)
{
	self->priv = bluetooth_device_row_get_instance_private (self);
}

static void
bluetooth_device_row_finalize (GObject * obj)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->connect_button);
	_g_object_unref0 (self->priv->forget_button);
	_g_object_unref0 (self->priv->state);
	_g_object_unref0 (self->priv->state_label);
	_g_object_unref0 (self->priv->settings_button);
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
}

static GType
bluetooth_device_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
	GType bluetooth_device_row_type_id;
	bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
	BluetoothDeviceRow_private_offset = g_type_add_instance_private (bluetooth_device_row_type_id, sizeof (BluetoothDeviceRowPrivate));
	return bluetooth_device_row_type_id;
}

GType
bluetooth_device_row_get_type (void)
{
	static volatile gsize bluetooth_device_row_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__volatile)) {
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = bluetooth_device_row_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_type_id__volatile, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__volatile;
}

static void
_vala_bluetooth_device_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_device (self));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bluetooth_device_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		bluetooth_device_row_set_device (self, g_value_get_object (value));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

